#! /bin/bash

echo "Removing old files"
rm -rf cwb_out/
mkdir cwb_out/
mkdir cwb_out/data/
mkdir cwb_out/registry/
rm -rf intermediate/
mkdir intermediate/
echo "Running preprocess script"
./preprocess.pl
echo "Done with preprocess, running R script"
Rscript ./ceg_process.R
echo "Done with R script, running postprocess"
./postprocess.pl
echo "Done with postprocess, concatenating all files"
cat intermediate/*.vrt > intermediate/ceg.vrt
echo "Done concatenating"

echo "Encoding corpus"
cwb-encode -d cwb_out/data -f intermediate/ceg.vrt -R cwb_out/registry/ceg -xsB -P pos -P lemma -P mut -S s:0 -S text:0+id+author+title+date+type_cy+type_en -S genre:0+cy+en
export CORPUS_REGISTRY=cwb_out/registry
cwb-makeall -V CEG
echo "Done encoding corpus, copying information files"

cp info/.info cwb_out/data/.info
cp info/ceg cwb_out/registry/ceg
cp info/README.md cwb_out/README.md

echo "Compressing to release package"
tar -cJ cwb_out/* > ceg_cwb.tar.xz

rm intermediate/*
echo "Done!"
