#!/usr/bin/perl -w

use warnings;
use Text::CSV;
my $csv = Text::CSV->new({ sep_char => ',' });
 
my $file = "data/CegInfo.csv";

open(my $data, '<', $file) or die "Could not open '$file' $!\n";
while (my $line = <$data>) {
  chomp $line;
 
  if ($csv->parse($line)) {
 
      my @fields = $csv->fields();
      $i = $fields[0];
      if ($i ne "File") {
          
          $ifile = "intermediate/$i.post";
          $ofile = "intermediate/$i.vrt";
    
            open my $in, "<", $ifile or die "Can't open $ifile\r\n $!";
            open my $out, ">", $ofile or die "Can't open $ofile\r\n $!";
    
            print $out "<text id=\"$i\" author=\"$fields[2]\" title=\"$fields[3]\" date=\"$fields[4]\" type_cy=\"$fields[6]\" type_en=\"$fields[7]\">\n";
            print $out "<genre cy=\"$fields[9]\" en=\"$fields[10]\">\n<s>\n";
    
            while (<$in>) {
                if($_ =~ "^(\\.|\!|\\?)\tpunct\t(\\.|\!|\\?)\tdim\n") {
                    if(eof) {
                        print $out $_;
                    } else {
                        print $out "$_</s>\n<s>\n";
                    }
                } else {
                    print $out $_;
                }
            }
    
            print $out "</s>\n</genre>\n</text>\n";
    
            close $out;
            close $in;
      }
 
  } else {
      warn "Line could not be parsed: $line\n";
  }
}